      SUBROUTINE G1G2N(X,QM2,G1,DG1,G2,DG2)
CCCCCCC
CCCCCCC                  EVALUATE TOTAL G1 AND G2 FOR THE NEUTRON
CCCCCCC
CCCCCCC                  X        : BJ VARIABLE
CCCCCCC                  QM2      : SQUARED 4-MOMENTUM TRANSFER IN (GEV/C)^2
CCCCCCC                  G1, G2   : STRUCTURE FUNCTIONS
CCCCCCC                  DG1, DG2 : UNCERTAINTIES
CCCCCCC                 NOTE: modified to output x*g1 and x*g2 [W.M.]
CCCCCCC
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA DMN/0.938256D0/,DMPI/0.134976D0/
      SAVE
      Q2=DMAX1(1.D-04,QM2)
      G1=0.D0
      DG1=0.D0
      G2=0.D0
      DG2=0.D0
      XPI=Q2/(Q2+2.D0*DMN*DMPI+DMPI*DMPI)
      IF((X.LE.0.D0).OR.(X.GE.XPI)) RETURN
      W=DSQRT(DMN*DMN+Q2*(1.D0-X)/X)
      CALL G1G2NRES(W,X,Q2,G1RS,DG1RS,G2RS,DG2RS)
      CALL G1G2NDIS(W,X,Q2,G1DIS,DG1DIS,G2DIS,DG2DIS)
      G1=G1RS+G1DIS
      DG1=DSQRT(DG1RS**2+DG1DIS**2)
      G2=G2RS+G2DIS
      DG2=DSQRT(DG2RS**2+DG2DIS**2)
        g1=x*g1
        Dg1=x*Dg1
        g2=x*g2
        Dg2=x*Dg2
      RETURN
      END



      SUBROUTINE G1G2NRES(W,X,Q2,G1R,DG1R,G2R,DG2R)
CCCCCCC
CCCCCCC                  EVALUATE RESONANCE CONTRIBUTION TO G1 AND G2 OF THE NEUTRON
CCCCCCC
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A1R(9),CR(9),BR(9),GR(9),ALT(9),DMR(9),
     *          DCR(9)
      DIMENSION LR(9),XR(9)
      DATA A1R/-0.560D0,1.D0,1.D0,1.D0,1.D0,1.D0,0.200D0,
     *         -0.500D0,-0.240D0/,
     *     CR/0.290D0,0.040D0,0.175D0,0.045D0,0.D0,0.090D0,
     *        0.135D0,0.055D0,0.125D0/,
     *     BR/0.70D0,1.60D0,0.80D0,0.60D0,1.0D0,0.60D0,1.0D0,
     *        0.60D0,0.60D0/,
     *     GR/0.105D0,0.30D0,0.20D0,0.15D0,0.15D0,0.13D0,0.30D0,
     *        0.25D0,0.25D0/,
     *     ALT/0.10D0,-0.20D0,-0.20D0,-0.20D0,0.30D0,-0.30D0,
     *         0.30D0,0.30D0,0.30D0/
     *     DMR/1.232D0,1.440D0,1.520D0,1.535D0,1.650D0,1.680D0,
     *         1.700D0,1.905D0,1.950D0/,
     *     DCR/0.05D0,0.25D0,0.10D0,0.60D0,0.30D0,0.15D0,0.30D0,
     *         0.60D0,0.20D0/
      DATA LR/1,1,2,1,1,3,2,3,3/,XR/0.160D0,0.350D0,0.350D0,0.350D0,
     *        0.350D0,0.350D0,0.350D0,0.350D0,0.350D0/  
      DATA DMN/0.938256D0/,DMPI/0.134976D0/,AEM/137.04D0/,
     *     PGRECO/3.141592654D0/
      SAVE
      G1R=0.D0
      DG1R=0.D0
      G2R=0.D0
      DG2R=0.D0
c      IF(IN.NE.0) RETURN
      Q=DSQRT(Q2)
      QSW=0.25D0*((W*W+DMN*DMN-DMPI*DMPI)/W)**2-DMN*DMN
      QSW=DSQRT(DMAX1(1.D-08,QSW))  
      DO 500 IR=1,9
      C1=CR(IR)
      IF(IR.EQ.1) C1=C1*DSQRT(1.D0+1.50D0*(Q2/0.14D0)*
     *               DEXP(-Q2/0.14D0))
      A1=A1R(IR)
      IF(IR.EQ.3) A1=1.D0-DEXP(0.53D0-0.51D0*Q)
      IF(IR.EQ.6) A1=1.D0-DEXP(0.67D0-0.95D0*Q)   
      A12=DSQRT(0.5D0*(1.D0+A1))*C1*DEXP(-BR(IR)*Q2)
      A32=DSQRT(0.5D0*(1.D0-A1))*C1*DEXP(-BR(IR)*Q2)
      WR=DMR(IR)
      QSR=DSQRT(0.25D0*((WR*WR+DMN*DMN-DMPI*DMPI)/WR)**2-DMN*DMN)
      NR=LR(IR)
      XR2=XR(IR)*XR(IR)
      GW=GR(IR)*((QSW/QSR)**(2*NR+1))*((QSR*QSR+XR2)/(QSW*QSW+XR2))**NR
      FCT=4.D0*DMN*WR*QSR*QSR*GW/(QSW*QSW)
      S12=FCT*A12*A12/((W*W-WR*WR)**2+WR*WR*GW*GW)
      S32=FCT*A32*A32/((W*W-WR*WR)**2+WR*WR*GW*GW)
      QSTAR=DSQRT(Q2+0.25D0*((W*W-DMN*DMN-Q2)/W)**2)
      SLT=ALT(IR)*DSQRT(Q2)*S12/(DSQRT(2.D0)*QSTAR)      
      SUM1R=0.5D0*(S12-S32)+2.D0*DMN*X*SLT/DSQRT(Q2)
      SUM2R=0.5D0*(S12-S32)+DSQRT(Q2)*SLT/(2.D0*DMN*X)
      DR=DMIN1(1.D0,(DCR(IR)+0.250D0*BR(IR)*Q2))
      G1R=G1R+SUM1R
      DG1R=DG1R+(DR*SUM1R)**2
      G2R=G2R+SUM2R 
      DG2R=DG2R+(DR*SUM2R)**2
  500 CONTINUE  
      CONV=AEM*Q2*(1.D0-X)/(8.D0*PGRECO*PGRECO*X*
     *     (1.D0+4.D0*DMN*DMN*X*X/Q2))
      G1R=G1R*CONV
      DG1R=CONV*DSQRT(DG1R)
      G2R=-G2R*CONV
      DG2R=CONV*DSQRT(DG2R)
      RETURN
      END



      SUBROUTINE G1G2NDIS(W,X,Q2,G1,DG1,G2,DG2)
CCCCCCC
CCCCCCC                  EVALUATE BACKGROUND CONTRIBUTION TO G1 AND G2 OF THE NEUTRON
CCCCCCC
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AXX(3),NXX(2),XX(120),WXX(120)
      DATA DMN/0.938256D0/,WPI/1.073232D0/,AEM/137.04D0/,
     *     PGRECO/3.141592654D0/
      SAVE
CCCCCCC
CCCCCCC                         FIT FOR DIS
CCCCCCC
      CALL FITNDIS(W,Q2,SGM)
      CONV=AEM*Q2*(1.D0-X)/(16.D0*PGRECO*PGRECO*X*(1.D0+
     +     4.D0*DMN*DMN*X*X/Q2))
      G1=CONV*SGM
      G2=-G1
      XPI=Q2/(Q2+WPI*WPI-DMN*DMN)
      SUMX=0.D0
      IF(X.GE.(XPI-1.D-04)) GO TO 750
      AXX(1)=X
      AXX(2)=XPI
      NXX(1)=60
      CALL DMP_n(1,NPOINTX,NXX,AXX,XX,WXX)
      DO 500 IX=1,NPOINTX
      XP=XX(IX)
      WW=DSQRT(DMN*DMN+Q2*(1.D0-XP)/XP)
      CALL FITNDIS(WW,Q2,SGM)
      SUMX=SUMX+WXX(IX)*SGM*(1.D0-XP)/(XP*XP*(1.D0+
     +     4.D0*DMN*DMN*XP*XP/Q2))
  500 CONTINUE
      SUMX=AEM*Q2*SUMX*DSQRT(1.D0-WPI*WPI/(W*W))/
     /     (16.D0*PGRECO*PGRECO)
  750 G1=G1+4.D0*DMN*DMN*X*X*SUMX/Q2
      G2=G2+SUMX
      DG1=0.20D0*(1.D0-0.50D0*X/XPI)*DABS(G1)
      DG2=0.20D0*(1.D0-0.50D0*X/XPI)*DABS(G2)
      RETURN
      END



      SUBROUTINE FITNDIS(W,Q2,SGM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA DMN/0.938256D0/,WPI/1.073232D0/,DL2/0.06250D0/
      DATA AA1/5.642212629D-01/,AA2/-1.149851441D+00/,
     *     FF1/-3.392868638D-01/,FF2/2.920268774D-01/,
     *     ALA1/-1.506777883D+00/,ALA2/-1.765760183D+00/,
     *     ALF1/-1.023614407D-02/,ALF2/6.925693750D-01/,
     *     P1A/1.238644719D-01/,P2A/1.936152649D+01/,
     *     P1F/4.027051926D+00/,P2F/4.365823746D+00/,
     *     DMR/2.768269062D+00/,DMT/4.509679079D-01/,
     *     Q02/9.932509065D-01/
      SAVE
      W2=W*W
      T=DLOG(DLOG((Q2+Q02)/DL2)/DLOG(Q02/DL2))
      PA=P1A+P2A*T
      PF=P1F+P2F*T
      AA=ALA1+ALA2*T
      AF=ALF1+ALF2*T
      FF=1.D0+W2/(DMR*DMR+Q2)
      A=(AA1+AA2*T)*(FF**AA)
      F=(FF1+FF2*T)*(FF**AF)
      FTHR=(W2-WPI*WPI)/(W2-WPI*WPI+Q2+DMT*DMT)
      SGM=(A*(FTHR**PA)+F*(FTHR**PF))/W2
      RETURN
      END

********************************************************************************

      SUBROUTINE DMP_n(MX,NPX,NX,AX,X,WX)
      IMPLICIT REAL*8 (A-H,O-Z)
CCCCCCC
CCCCCCC              IMPOSTA I PUNTI DI INTEGRAZIONE E I PESI
CCCCCCC                        NELLA VARIABILE X
CCCCCCC
CCCCCCC              MX = NUMERO DEI SOTTOINTERVALLI
CCCCCCC              NX(MX) = NUMERO DEI PUNTI NEI SOTTOINTERVALLI
CCCCCCC              AX(MX+1) = ESTREMI DEI SOTTOINTERVALLI
CCCCCCC              X = VARIABILE DI INTEGRAZIONE
CCCCCCC              WX = PESI NELLA VARIABILE X
CCCCCCC
      DIMENSION NX(1),AX(1),X(1),WX(1)
      DIMENSION POINT(60),WEIGHT(60)
      IF(MX.GT.0) GO TO 5
      WRITE(6,1000)
 1000 FORMAT(//,10X,'WARNING FROM DMP: MX MUST BE POSITIVE',//)
c      CALL EXIT
	return
    5 L0=0
      DO 30 I=1,MX
      NPX=NX(I)
      IF(NPX.LE.0) GO TO 30
      CALL DVKN_n(NPX)
      CALL GPT_n(POINT,NPX)
      CALL GWT_n(WEIGHT,NPX)
      DF=0.5D0*(AX(I+1)-AX(I))
      IF(DABS(DF).GE.1.D-08) GO TO 10
      WRITE(6,2000)
 2000 FORMAT(//,10X,'WARNING FROM DMP: VALUE OF |DF| NOT ALLOWED',//)
c      CALL EXIT
	return
   10 DS=0.5D0*(AX(I+1)+AX(I))
      DO 20 L=1,NPX
      WX(L0+L)=DF*WEIGHT(L)
   20 X(L0+L)=DS+DF*POINT(L)
      L0=L0+NPX
   30 CONTINUE
      NPX=L0
      IF(L0.GT.0) RETURN
      WRITE(6,3000)
 3000 FORMAT(//,10X,'WARNING FROM DMP: VERIFY INTEGRATION POINTS',//)
c      CALL EXIT
      RETURN
      END
      SUBROUTINE DVKN_n(N)
CCCCCCC
CCCCCCC                 CHECK SUL VALORE DI N
CCCCCCC       (N=4,8,12,16,20,24,28,32,36,40,44,48,52,56,60)
CCCCCCC
      M=N/4
      IF(M.LE.0) GO TO 1
      IF((N-4*M).NE.0) GO TO 1
      IF(M.GT.15) GO TO 1
      RETURN
    1 WRITE(6,1000)
 1000 FORMAT(//,10X,'WARNING FROM DVKN: VALUE OF N NOT ALLOWED',//)
c      CALL EXIT
      RETURN
      END
      SUBROUTINE GPT_n(P,N)
CCCCCCC
CCCCCCC        IMPOSTA I PUNTI DI GAUSS-LEGENDRE NEL VETTORE P
CCCCCCC        (N=4,8,12,16,20,24,28,32,36,40,44,48,52,56,60)
CCCCCCC                        ( -1<P<1 )
CCCCCCC
      DOUBLE PRECISION P(60)
      L=N/4
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15), L
    1 CONTINUE
      P(1)=0.8611363115940526D0
      P(2)=0.3399810435848563D0
      GO TO 40
    2 CONTINUE
      P(1)=0.9602898564975362D0
      P(2)=0.7966664774136267D0
      P(3)=0.5255324099163290D0
      P(4)=0.1834346424956498D0
      GO TO 40
    3 CONTINUE
      P(1)=0.9815606342467193D0
      P(2)=0.9041172563704749D0
      P(3)=0.7699026741943047D0
      P(4)=0.5873179542866175D0
      P(5)=0.3678314989981802D0
      P(6)=0.1252334085114689D0
      GO TO 40
    4 CONTINUE
      P(1)=0.9894009349916499D0
      P(2)=0.9445750230732326D0
      P(3)=0.8656312023878317D0
      P(4)=0.7554044083550030D0
      P(5)=0.6178762444026438D0
      P(6)=0.4580167776572274D0
      P(7)=0.2816035507792589D0
      P(8)=0.9501250983763744D-01
      GO TO 40
    5 CONTINUE
      P(1)=0.9931285991850949D0
      P(2)=0.9639719272779138D0
      P(3)=0.9122344282513259D0
      P(4)=0.8391169718222188D0
      P(5)=0.7463319064601508D0
      P(6)=0.6360536807265150D0
      P(7)=0.5108670019508271D0
      P(8)=0.3737060887154196D0
      P(9)=0.2277858511416451D0
      P(10)=0.7652652113349733D-01
      GO TO 40
    6 CONTINUE
      P(1)=0.9951872199970214D0
      P(2)=0.9747285559713095D0
      P(3)=0.9382745520027328D0
      P(4)=0.8864155270044010D0
      P(5)=0.8200019859739029D0
      P(6)=0.7401241915785544D0
      P(7)=0.6480936519369756D0
      P(8)=0.5454214713888395D0
      P(9)=0.4337935076260451D0
      P(10)=0.3150426796961634D0
      P(11)=0.1911188674736163D0
      P(12)=0.6405689286260563D-01
      GO TO 40
    7 CONTINUE
      P(1)=0.9964424975739544D0
      P(2)=0.9813031653708728D0
      P(3)=0.9542592806289382D0
      P(4)=0.9156330263921321D0
      P(5)=0.8658925225743950D0
      P(6)=0.8056413709171792D0
      P(7)=0.7356108780136318D0
      P(8)=0.6566510940388650D0
      P(9)=0.5697204718114017D0
      P(10)=0.4758742249551183D0
      P(11)=0.3762515160890787D0
      P(12)=0.2720616276351781D0
      P(13)=0.1645692821333808D0
      P(14)=0.5507928988403427D-01
      GO TO 40
    8 CONTINUE
      P(1)=0.9972638618494816D0
      P(2)=0.9856115115452683D0
      P(3)=0.9647622555875064D0
      P(4)=0.9349060759377397D0
      P(5)=0.8963211557660521D0
      P(6)=0.8493676137325700D0
      P(7)=0.7944837959679424D0
      P(8)=0.7321821187402897D0
      P(9)=0.6630442669302152D0
      P(10)=0.5877157572407623D0
      P(11)=0.5068999089322294D0
      P(12)=0.4213512761306353D0
      P(13)=0.3318686022821276D0
      P(14)=0.2392873622521371D0
      P(15)=0.1444719615827965D0
      P(16)=0.4830766568773832D-01
      GO TO 40
    9 CONTINUE
      P(1)=0.9978304624840858D0
      P(2)=0.9885864789022122D0
      P(3)=0.9720276910496980D0
      P(4)=0.9482729843995076D0
      P(5)=0.9174977745156591D0
      P(6)=0.8799298008903971D0
      P(7)=0.8358471669924753D0
      P(8)=0.7855762301322065D0
      P(9)=0.7294891715935566D0
      P(10)=0.6680012365855211D0
      P(11)=0.6015676581359805D0
      P(12)=0.5306802859262452D0
      P(13)=0.4558639444334203D0
      P(14)=0.3776725471196892D0
      P(15)=0.2966849953440283D0
      P(16)=0.2135008923168656D0
      P(17)=0.1287361038093848D0
      P(18)=0.4301819847370861D-01
      GO TO 40
   10 CONTINUE
      P(1)=0.9982377097105592D0
      P(2)=0.9907262386994570D0
      P(3)=0.9772599499837743D0
      P(4)=0.9579168192137917D0
      P(5)=0.9328128082786765D0
      P(6)=0.9020988069688743D0
      P(7)=0.8659595032122595D0
      P(8)=0.8246122308333117D0
      P(9)=0.7783056514265194D0
      P(10)=0.7273182551899271D0
      P(11)=0.6719566846141795D0
      P(12)=0.6125538896679802D0
      P(13)=0.5494671250951282D0
      P(14)=0.4830758016861787D0
      P(15)=0.4137792043716050D0
      P(16)=0.3419940908257585D0
      P(17)=0.2681521850072537D0
      P(18)=0.1926975807013711D0
      P(19)=0.1160840706752552D0
      P(20)=0.3877241750605082D-01
      GO TO 40
   11 CONTINUE
      P(1)=0.9985402006367742D0
      P(2)=0.9923163921385158D0
      P(3)=0.9811518330779140D0
      P(4)=0.9650996504224931D0
      P(5)=0.9442395091181941D0
      P(6)=0.9186752599841758D0
      P(7)=0.8885342382860432D0
      P(8)=0.8539665950047104D0
      P(9)=0.8151445396451350D0
      P(10)=0.7722614792487559D0
      P(11)=0.7255310536607170D0
      P(12)=0.6751860706661224D0
      P(13)=0.6214773459035758D0
      P(14)=0.5646724531854708D0
      P(15)=0.5050543913882023D0
      P(16)=0.4429201745254115D0
      P(17)=0.3785793520147071D0
      P(18)=0.3123524665027858D0
      P(19)=0.2445694569282013D0
      P(20)=0.1755680147755168D0
      P(21)=0.1056919017086532D0
      P(22)=0.3528923696413536D-01
      GO TO 40
   12 CONTINUE
      P(1)=0.9987710072524261D0
      P(2)=0.9935301722663508D0
      P(3)=0.9841245837228269D0
      P(4)=0.9705915925462473D0
      P(5)=0.9529877031604309D0
      P(6)=0.9313866907065543D0
      P(7)=0.9058791367155697D0
      P(8)=0.8765720202742479D0
      P(9)=0.8435882616243935D0
      P(10)=0.8070662040294426D0
      P(11)=0.7671590325157403D0
      P(12)=0.7240341309238147D0
      P(13)=0.6778723796326639D0
      P(14)=0.6288673967765136D0
      P(15)=0.5772247260839727D0
      P(16)=0.5231609747222330D0
      P(17)=0.4669029047509584D0
      P(18)=0.4086864819907167D0
      P(19)=0.3487558862921607D0
      P(20)=0.2873624873554556D0
      P(21)=0.2247637903946891D0
      P(22)=0.1612223560688917D0
      P(23)=0.9700469920946270D-01
      P(24)=0.3238017096286936D-01
      GO TO 40
   13 CONTINUE
      P(1)=0.9989511111039503D+00
      P(2)=0.9944775909292160D+00
      P(3)=0.9864461956515498D+00
      P(4)=0.9748838842217445D+00
      P(5)=0.9598318269330866D+00
      P(6)=0.9413438536413591D+00
      P(7)=0.9194861289164245D+00
      P(8)=0.8943368905344953D+00
      P(9)=0.8659861628460676D+00
      P(10)=0.8345354323267345D+00
      P(11)=0.8000972834304683D+00
      P(12)=0.7627949951937450D+00
      P(13)=0.7227620997499832D+00
      P(14)=0.6801419042271677D+00
      P(15)=0.6350869776952459D+00
      P(16)=0.5877586049795791D+00
      P(17)=0.5383262092858274D+00
      P(18)=0.4869667456980961D+00
      P(19)=0.4338640677187617D+00
      P(20)=0.3792082691160937D+00
      P(21)=0.3231950034348078D+00
      P(22)=0.2660247836050018D+00
      P(23)=0.2079022641563661D+00
      P(24)=0.1490355086069492D+00
      P(25)=0.8963524464890057D-01
      P(26)=0.2991410979733877D-01
      GO TO 40
   14 CONTINUE
      P(1)=0.9990943438014656D+00
      P(2)=0.9952312260810697D+00
      P(3)=0.9882937155401615D+00
      P(4)=0.9783017091402564D+00
      P(5)=0.9652859019054902D+00
      P(6)=0.9492864795619626D+00
      P(7)=0.9303528802474963D+00
      P(8)=0.9085436204206555D+00
      P(9)=0.8839261083278275D+00
      P(10)=0.8565764337627486D+00
      P(11)=0.8265791321428817D+00
      P(12)=0.7940269228938665D+00
      P(13)=0.7590204227051289D+00
      P(14)=0.7216678344501881D+00
      P(15)=0.6820846126944705D+00
      P(16)=0.6403931068070069D+00
      P(17)=0.5967221827706633D+00
      P(18)=0.5512068248555346D+00
      P(19)=0.5039877183843817D+00
      P(20)=0.4552108148784596D+00
      P(21)=0.4050268809270913D+00
      P(22)=0.3535910321749545D+00
      P(23)=0.3010622538672207D+00
      P(24)=0.2476029094343372D+00
      P(25)=0.1933782386352753D+00
      P(26)=0.1385558468103762D+00
      P(27)=0.8330518682243537D-01
      P(28)=0.2779703528727544D-01
      GO TO 40
   15 CONTINUE
      P(1)=0.9992101232274360D+00
      P(2)=0.9958405251188382D+00
      P(3)=0.9897878952222217D+00
      P(4)=0.9810672017525982D+00
      P(5)=0.9697017887650527D+00
      P(6)=0.9557222558399961D+00
      P(7)=0.9391662761164232D+00
      P(8)=0.9200784761776276D+00
      P(9)=0.8985103108100459D+00
      P(10)=0.8745199226468983D+00
      P(11)=0.8481719847859296D+00
      P(12)=0.8195375261621458D+00
      P(13)=0.7886937399322641D+00
      P(14)=0.7557237753065857D+00
      P(15)=0.7207165133557304D+00
      P(16)=0.6837663273813554D+00
      P(17)=0.6449728284894771D+00
      P(18)=0.6044405970485104D+00
      P(19)=0.5622789007539445D+00
      P(20)=0.5186014000585697D+00
      P(21)=0.4735258417617071D+00
      P(22)=0.4271737415830784D+00
      P(23)=0.3796700565767980D+00
      P(24)=0.3311428482684482D+00
      P(25)=0.2817229374232617D+00
      P(26)=0.2315435513760293D+00
      P(27)=0.1807399648734254D+00
      P(28)=0.1294491353969450D+00
      P(29)=0.7780933394953657D-01
      P(30)=0.2595977230124780D-01
   40 M=N/2+1
      J=M
      DO 50 I=M,N
      J=J-1
      P(I)=P(J)
   50 P(J)=-P(J)
      RETURN
      END
      SUBROUTINE GWT_n(W,N)
CCCCCCC
CCCCCCC        IMPOSTA I PESI DI GAUSS-LEGENDRE NEL VETTORE W
CCCCCCC        (N=4,8,12,16,20,24,28,32,36,40,44,48,52,56,60)
CCCCCCC
      DOUBLE PRECISION W(60)
      L=N/4
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15), L
    1 CONTINUE
      W(1)=0.3478548451374539D0
      W(2)=0.6521451548625461D0
      GO TO 40
    2 CONTINUE
      W(1)=0.1012285362903763D0
      W(2)=0.2223810344533745D0
      W(3)=0.3137066458778873D0
      W(4)=0.3626837833783620D0
      GO TO 40
    3 CONTINUE
      W(1)=0.4717533638651183D-01
      W(2)=0.1069393259953184D0
      W(3)=0.1600783285433462D0
      W(4)=0.2031674267230659D0
      W(5)=0.2334925365383548D0
      W(6)=0.2491470458134028D0
      GO TO 40
    4 CONTINUE
      W(1)=0.2715245941175410D-01
      W(2)=0.6225352393864789D-01
      W(3)=0.9515851168249279D-01
      W(4)=0.1246289712555339D0
      W(5)=0.1495959888165767D0
      W(6)=0.1691565193950025D0
      W(7)=0.1826034150449236D0
      W(8)=0.1894506104550685D0
      GO TO 40
    5 CONTINUE
      W(1)=0.1761400713915212D-01
      W(2)=0.4060142980038694D-01
      W(3)=0.6267204833410906D-01
      W(4)=0.8327674157670475D-01
      W(5)=0.1019301198172404D0
      W(6)=0.1181945319615184D0
      W(7)=0.1316886384491766D0
      W(8)=0.1420961093183821D0
      W(9)=0.1491729864726037D0
      W(10)=0.1527533871307259D0
      GO TO 40
    6 CONTINUE
      W(1)=0.1234122979998720D-01
      W(2)=0.2853138862893367D-01
      W(3)=0.4427743881741981D-01
      W(4)=0.5929858491543678D-01
      W(5)=0.7334648141108031D-01
      W(6)=0.8619016153195328D-01
      W(7)=0.9761865210411389D-01
      W(8)=0.1074442701159656D0
      W(9)=0.1155056680537256D0
      W(10)=0.1216704729278034D0
      W(11)=0.1258374563468283D0
      W(12)=0.1279381953467522D0
      GO TO 40
    7 CONTINUE
      W(1)=0.9124282593094518D-02
      W(2)=0.2113211259277126D-01
      W(3)=0.3290142778230438D-01
      W(4)=0.4427293475900423D-01
      W(5)=0.5510734567571675D-01
      W(6)=0.6527292396699960D-01
      W(7)=0.7464621423456878D-01
      W(8)=0.8311341722890122D-01
      W(9)=0.9057174439303284D-01
      W(10)=0.9693065799792992D-01
      W(11)=0.1021129675780608D0
      W(12)=0.1060557659228464D0
      W(13)=0.1087111922582941D0
      W(14)=0.1100470130164752D0
      GO TO 40
    8 CONTINUE
      W(1)=0.7018610009470097D-02
      W(2)=0.1627439473090567D-01
      W(3)=0.2539206530926206D-01
      W(4)=0.3427386291302143D-01
      W(5)=0.4283589802222668D-01
      W(6)=0.5099805926237618D-01
      W(7)=0.5868409347853555D-01
      W(8)=0.6582222277636185D-01
      W(9)=0.7234579410884851D-01
      W(10)=0.7819389578707031D-01
      W(11)=0.8331192422694676D-01
      W(12)=0.8765209300440381D-01
      W(13)=0.9117387869576388D-01
      W(14)=0.9384439908080457D-01
      W(15)=0.9563872007927486D-01
      W(16)=0.9654008851472780D-01
      GO TO 40
    9 CONTINUE
      W(1)=0.5565719664245045D-02
      W(2)=0.1291594728406557D-01
      W(3)=0.2018151529773547D-01
      W(4)=0.2729862149856878D-01
      W(5)=0.3421381077030723D-01
      W(6)=0.4087575092364490D-01
      W(7)=0.4723508349026598D-01
      W(8)=0.5324471397775992D-01
      W(9)=0.5886014424532482D-01
      W(10)=0.6403979735501549D-01
      W(11)=0.6874532383573644D-01
      W(12)=0.7294188500565306D-01
      W(13)=0.7659841064587068D-01
      W(14)=0.7968782891207160D-01
      W(15)=0.8218726670433971D-01
      W(16)=0.8407821897966194D-01
      W(17)=0.8534668573933863D-01
      W(18)=0.8598327567039475D-01
      GO TO 40
   10 CONTINUE
      W(1)=0.4521277098533191D-02
      W(2)=0.1049828453115281D-01
      W(3)=0.1642105838190789D-01
      W(4)=0.2224584919416696D-01
      W(5)=0.2793700698002340D-01
      W(6)=0.3346019528254785D-01
      W(7)=0.3878216797447202D-01
      W(8)=0.4387090818567327D-01
      W(9)=0.4869580763507223D-01
      W(10)=0.5322784698393682D-01
      W(11)=0.5743976909939155D-01
      W(12)=0.6130624249292894D-01
      W(13)=0.6480401345660104D-01
      W(14)=0.6791204581523390D-01
      W(15)=0.7061164739128678D-01
      W(16)=0.7288658239580406D-01
      W(17)=0.7472316905796826D-01
      W(18)=0.7611036190062624D-01
      W(19)=0.7703981816424797D-01
      W(20)=0.7750594797842481D-01
      GO TO 40
   11 CONTINUE
      W(1)=0.3745404803112778D-02
      W(2)=0.8700481367524844D-02
      W(3)=0.1361958675557999D-01
      W(4)=0.1847148173681475D-01
      W(5)=0.2323148190201921D-01
      W(6)=0.2787578282128101D-01
      W(7)=0.3238122281206982D-01
      W(8)=0.3672534781380887D-01
      W(9)=0.4088651231034622D-01
      W(10)=0.4484398408197003D-01
      W(11)=0.4857804644835204D-01
      W(12)=0.5207009609170446D-01
      W(13)=0.5530273556372805D-01
      W(14)=0.5825985987759550D-01
      W(15)=0.6092673670156197D-01
      W(16)=0.6329007973320385D-01
      W(17)=0.6533811487918143D-01
      W(18)=0.6706063890629365D-01
      W(19)=0.6844907026936666D-01
      W(20)=0.6949649186157258D-01
      W(21)=0.7019768547355821D-01
      W(22)=0.7054915778935407D-01
      GO TO 40
   12 CONTINUE
      W(1)=0.3153346052305839D-02
      W(2)=0.7327553901276262D-02
      W(3)=0.1147723457923454D-01
      W(4)=0.1557931572294385D-01
      W(5)=0.1961616045735553D-01
      W(6)=0.2357076083932438D-01
      W(7)=0.2742650970835695D-01
      W(8)=0.3116722783279809D-01
      W(9)=0.3477722256477044D-01
      W(10)=0.3824135106583071D-01
      W(11)=0.4154508294346475D-01
      W(12)=0.4467456085669428D-01
      W(13)=0.4761665849249047D-01
      W(14)=0.5035903555385447D-01
      W(15)=0.5289018948519367D-01
      W(16)=0.5519950369998416D-01
      W(17)=0.5727729210040322D-01
      W(18)=0.5911483969839564D-01
      W(19)=0.6070443916589388D-01
      W(20)=0.6203942315989266D-01
      W(21)=0.6311419228625403D-01
      W(22)=0.6392423858464819D-01
      W(23)=0.6446616443595008D-01
      W(24)=0.6473769681268392D-01
      GO TO 40
   13 CONTINUE
      W(1)=0.2691316950047111D-02
      W(2)=0.6255523962973277D-02
      W(3)=0.9802634579462752D-02
      W(4)=0.1331511498234096D-01
      W(5)=0.1678002339630074D-01
      W(6)=0.2018489150798079D-01
      W(7)=0.2351751355398446D-01
      W(8)=0.2676595374650401D-01
      W(9)=0.2991858114714395D-01
      W(10)=0.3296410908971880D-01
      W(11)=0.3589163483509723D-01
      W(12)=0.3869067831042398D-01
      W(13)=0.4135121950056027D-01
      W(14)=0.4386373425900041D-01
      W(15)=0.4621922837278479D-01
      W(16)=0.4840926974407490D-01
      W(17)=0.5042601856634238D-01
      W(18)=0.5226225538390699D-01
      W(19)=0.5391140693275726D-01
      W(20)=0.5536756966930265D-01
      W(21)=0.5662553090236860D-01
      W(22)=0.5768078745252683D-01
      W(23)=0.5852956177181387D-01
      W(24)=0.5916881546604297D-01
      W(25)=0.5959626017124816D-01
      W(26)=0.5981036574529186D-01
      GO TO 40
   14 CONTINUE
      W(1)=0.2323855375773216D-02
      W(2)=0.5402522246015338D-02
      W(3)=0.8469063163307888D-02
      W(4)=0.1150982434038338D-01
      W(5)=0.1451508927802147D-01
      W(6)=0.1747551291140095D-01
      W(7)=0.2038192988240257D-01
      W(8)=0.2322535156256532D-01
      W(9)=0.2599698705839195D-01
      W(10)=0.2868826847382274D-01
      W(11)=0.3129087674731045D-01
      W(12)=0.3379676711561176D-01
      W(13)=0.3619819387231519D-01
      W(14)=0.3848773425924766D-01
      W(15)=0.4065831138474452D-01
      W(16)=0.4270321608466709D-01
      W(17)=0.4461612765269228D-01
      W(18)=0.4639113337300190D-01
      W(19)=0.4802274679360026D-01
      W(20)=0.4950592468304758D-01
      W(21)=0.5083608261779848D-01
      W(22)=0.5200910915174140D-01
      W(23)=0.5302137852401076D-01
      W(24)=0.5386976186571449D-01
      W(25)=0.5455163687088942D-01
      W(26)=0.5506489590176243D-01
      W(27)=0.5540795250324512D-01
      W(28)=0.5557974630651440D-01
      GO TO 40
   15 CONTINUE
      W(1)=0.2026811968873758D-02
      W(2)=0.4712729926953569D-02
      W(3)=0.7389931163345456D-02
      W(4)=0.1004755718228798D-01
      W(5)=0.1267816647681596D-01
      W(6)=0.1527461859678480D-01
      W(7)=0.1782990101420772D-01
      W(8)=0.2033712072945729D-01
      W(9)=0.2278951694399782D-01
      W(10)=0.2518047762152125D-01
      W(11)=0.2750355674992479D-01
      W(12)=0.2975249150078895D-01
      W(13)=0.3192121901929633D-01
      W(14)=0.3400389272494642D-01
      W(15)=0.3599489805108450D-01
      W(16)=0.3788886756924344D-01
      W(17)=0.3968069545238080D-01
      W(18)=0.4136555123558476D-01
      W(19)=0.4293889283593564D-01
      W(20)=0.4439647879578711D-01
      W(21)=0.4573437971611449D-01
      W(22)=0.4694898884891220D-01
      W(23)=0.4803703181997118D-01
      W(24)=0.4899557545575684D-01
      W(25)=0.4982203569055018D-01
      W(26)=0.5051418453250937D-01
      W(27)=0.5107015606985563D-01
      W(28)=0.5148845150098093D-01
      W(29)=0.5176794317491019D-01
      W(30)=0.5190787763122064D-01
   40 M=N/2+1
      J=M
      DO 50 I=M,N
      J=J-1
   50 W(I)=W(J)
      RETURN
      END

      
