c************************************************
c   Nuclear spin structure functions
c
c   x    = Bjorken x
c   qsq  = Q**2 in GeV**2
c
c   The array az(2) defines nuclear mass and charge:
c   az(1) = A
c   az(2) = Z
c
c   The array g(2) returns nuclear spin structure functions:
c   g(1) = x*g_T
c   g(2) = x*g_L
c
c************************************************
      subroutine nucssf(x,qsq,az,g)
      implicit none
      include "globalpar.inc"
      integer nsf,ityp,kint,kord,ityp0
      real az(2),AA,ZZ
      real*8 x,qsq,g(2)
c      real*8 e1,e2,e2eff,norm0,norm1,mo,aCM
      real*8 cnv2,cnv3
c
      g(1)=0d0
      g(2)=0d0
c...Define the nucleus:
      AA=az(1)
      ZZ=az(2)
c
c FMB corrections computed for DEUTERIUM (A=2) and He-3 (A=3)
        if (NINT(AA).eq.2.and.NINT(ZZ).eq.1) then  !DEUTERIUM:
          g(1) = cnv2(x,qsq,ede,mN,1)  !/norm0
          g(2) = cnv2(x,qsq,ede,mN,2)  !/norm0
        elseif (NINT(AA).eq.3.and.nint(ZZ).eq.2) then  !HELIUM-3:
          
        else
          print *,'nucssf warning: nuclear number(s) out of range,
     +            A=',AA,' Z=',ZZ 
        end if
c
      return
      end
********END of nucssf***************************
