c************************************************
c   Nucleon spin structure functions
c
c   x    = Bjorken x
c   qsq  = Q**2 in GeV**2
c
c   id = nucleon type:
c   id=0  isoscalar nucleon
c   id=1  proton
c   id=2  neutron
c
c   nsf = type of the spin structure function:
c   nsf=1 x*g_1
c   nsf=2 x*g_2
c
c************************************************
      real*8 function ssf(id,x,qsq,nsf)
      implicit none
      include "globalpar.inc"
      integer nsf,id
      real*8 x,qsq
	REAL*8	QM2,G1p,DG1p,G2p,DG2p,G1n,DG1n,G2n,DG2n

	QM2=qsq
	CALL G1G2P(X,QM2,G1p,DG1p,G2p,DG2p)
	CALL G1G2N(X,QM2,G1n,DG1n,G2n,DG2n)
c
      ssf=0d0
c
        if (id.eq.1) then  !PROTON:
          ssf=G1p
        elseif (id.eq.2) then  !NEUTRON:
          ssf=G1n
        elseif (id.eq.0) then !(p+n)/2:
          ssf=(G1p+G1n)/2
        else  
          print *,'ssf warning: id is out of range, id=',id
        end if
c
      return
      end
********END of ssf***************************
