c************************************************
c   Nucleon spin structure functions
c
c   x    = Bjorken x
c   qsq  = Q**2 in GeV**2
c
c   id = nucleon type:
c   id=0  isoscalar nucleon
c   id=1  proton
c   id=2  neutron
c
c   nsf = type of the spin structure function:
c   nsf=1 x*g_1
c   nsf=2 x*g_2
c
c************************************************
      real*8 function ssf(id,x,qsq,nsf)
      implicit none
      include "globalpar.inc"
      integer nsf,id
      real*8 x,qsq
c
      ssf=0d0
c
        if (id.eq.1) then  !PROTON:
          ssf=1.d0
        elseif (id.eq.2) then  !NEUTRON:
          ssf=1.d0
        elseif (id.eq.0) then !(p+n)/2:
          ssf=1.d0
        else  
          print *,'ssf warning: id is out of range, id=',id
        end if
c
      return
      end
********END of ssf***************************
